// Code generated by go-swagger; DO NOT EDIT.

package authentication

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewServiceBrokerAuthTokenPostParams creates a new ServiceBrokerAuthTokenPostParams object
// with the default values initialized.
func NewServiceBrokerAuthTokenPostParams() *ServiceBrokerAuthTokenPostParams {
	var ()
	return &ServiceBrokerAuthTokenPostParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewServiceBrokerAuthTokenPostParamsWithTimeout creates a new ServiceBrokerAuthTokenPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewServiceBrokerAuthTokenPostParamsWithTimeout(timeout time.Duration) *ServiceBrokerAuthTokenPostParams {
	var ()
	return &ServiceBrokerAuthTokenPostParams{

		timeout: timeout,
	}
}

// NewServiceBrokerAuthTokenPostParamsWithContext creates a new ServiceBrokerAuthTokenPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewServiceBrokerAuthTokenPostParamsWithContext(ctx context.Context) *ServiceBrokerAuthTokenPostParams {
	var ()
	return &ServiceBrokerAuthTokenPostParams{

		Context: ctx,
	}
}

// NewServiceBrokerAuthTokenPostParamsWithHTTPClient creates a new ServiceBrokerAuthTokenPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewServiceBrokerAuthTokenPostParamsWithHTTPClient(client *http.Client) *ServiceBrokerAuthTokenPostParams {
	var ()
	return &ServiceBrokerAuthTokenPostParams{
		HTTPClient: client,
	}
}

/*ServiceBrokerAuthTokenPostParams contains all the parameters to send to the API endpoint
for the service broker auth token post operation typically these are written to a http.Request
*/
type ServiceBrokerAuthTokenPostParams struct {

	/*Body
	  Parameters for requesting a new Token from a Refresh Token

	*/
	Body *models.TokenRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) WithTimeout(timeout time.Duration) *ServiceBrokerAuthTokenPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) WithContext(ctx context.Context) *ServiceBrokerAuthTokenPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) WithHTTPClient(client *http.Client) *ServiceBrokerAuthTokenPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) WithBody(body *models.TokenRequest) *ServiceBrokerAuthTokenPostParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the service broker auth token post params
func (o *ServiceBrokerAuthTokenPostParams) SetBody(body *models.TokenRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ServiceBrokerAuthTokenPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
