// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_images

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewPcloudV2ImagesExportPostParams creates a new PcloudV2ImagesExportPostParams object
// with the default values initialized.
func NewPcloudV2ImagesExportPostParams() *PcloudV2ImagesExportPostParams {
	var ()
	return &PcloudV2ImagesExportPostParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPcloudV2ImagesExportPostParamsWithTimeout creates a new PcloudV2ImagesExportPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPcloudV2ImagesExportPostParamsWithTimeout(timeout time.Duration) *PcloudV2ImagesExportPostParams {
	var ()
	return &PcloudV2ImagesExportPostParams{

		timeout: timeout,
	}
}

// NewPcloudV2ImagesExportPostParamsWithContext creates a new PcloudV2ImagesExportPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewPcloudV2ImagesExportPostParamsWithContext(ctx context.Context) *PcloudV2ImagesExportPostParams {
	var ()
	return &PcloudV2ImagesExportPostParams{

		Context: ctx,
	}
}

// NewPcloudV2ImagesExportPostParamsWithHTTPClient creates a new PcloudV2ImagesExportPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPcloudV2ImagesExportPostParamsWithHTTPClient(client *http.Client) *PcloudV2ImagesExportPostParams {
	var ()
	return &PcloudV2ImagesExportPostParams{
		HTTPClient: client,
	}
}

/*PcloudV2ImagesExportPostParams contains all the parameters to send to the API endpoint
for the pcloud v2 images export post operation typically these are written to a http.Request
*/
type PcloudV2ImagesExportPostParams struct {

	/*Body
	  Parameters for the export

	*/
	Body *models.ExportImage
	/*CloudInstanceID
	  Cloud Instance ID of a PCloud Instance

	*/
	CloudInstanceID string
	/*ImageID
	  Image ID of a image

	*/
	ImageID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) WithTimeout(timeout time.Duration) *PcloudV2ImagesExportPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) WithContext(ctx context.Context) *PcloudV2ImagesExportPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) WithHTTPClient(client *http.Client) *PcloudV2ImagesExportPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) WithBody(body *models.ExportImage) *PcloudV2ImagesExportPostParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) SetBody(body *models.ExportImage) {
	o.Body = body
}

// WithCloudInstanceID adds the cloudInstanceID to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) WithCloudInstanceID(cloudInstanceID string) *PcloudV2ImagesExportPostParams {
	o.SetCloudInstanceID(cloudInstanceID)
	return o
}

// SetCloudInstanceID adds the cloudInstanceId to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) SetCloudInstanceID(cloudInstanceID string) {
	o.CloudInstanceID = cloudInstanceID
}

// WithImageID adds the imageID to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) WithImageID(imageID string) *PcloudV2ImagesExportPostParams {
	o.SetImageID(imageID)
	return o
}

// SetImageID adds the imageId to the pcloud v2 images export post params
func (o *PcloudV2ImagesExportPostParams) SetImageID(imageID string) {
	o.ImageID = imageID
}

// WriteToRequest writes these params to a swagger request
func (o *PcloudV2ImagesExportPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param cloud_instance_id
	if err := r.SetPathParam("cloud_instance_id", o.CloudInstanceID); err != nil {
		return err
	}

	// path param image_id
	if err := r.SetPathParam("image_id", o.ImageID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
