// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// PcloudNetworksPostReader is a Reader for the PcloudNetworksPost structure.
type PcloudNetworksPostReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PcloudNetworksPostReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewPcloudNetworksPostOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 201:
		result := NewPcloudNetworksPostCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewPcloudNetworksPostBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewPcloudNetworksPostUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 409:
		result := NewPcloudNetworksPostConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 422:
		result := NewPcloudNetworksPostUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewPcloudNetworksPostInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPcloudNetworksPostOK creates a PcloudNetworksPostOK with default headers values
func NewPcloudNetworksPostOK() *PcloudNetworksPostOK {
	return &PcloudNetworksPostOK{}
}

/*PcloudNetworksPostOK handles this case with default header values.

OK
*/
type PcloudNetworksPostOK struct {
	Payload *models.Network
}

func (o *PcloudNetworksPostOK) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostOK  %+v", 200, o.Payload)
}

func (o *PcloudNetworksPostOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Network)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPcloudNetworksPostCreated creates a PcloudNetworksPostCreated with default headers values
func NewPcloudNetworksPostCreated() *PcloudNetworksPostCreated {
	return &PcloudNetworksPostCreated{}
}

/*PcloudNetworksPostCreated handles this case with default header values.

Created
*/
type PcloudNetworksPostCreated struct {
	Payload *models.Network
}

func (o *PcloudNetworksPostCreated) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostCreated  %+v", 201, o.Payload)
}

func (o *PcloudNetworksPostCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Network)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPcloudNetworksPostBadRequest creates a PcloudNetworksPostBadRequest with default headers values
func NewPcloudNetworksPostBadRequest() *PcloudNetworksPostBadRequest {
	return &PcloudNetworksPostBadRequest{}
}

/*PcloudNetworksPostBadRequest handles this case with default header values.

Bad Request
*/
type PcloudNetworksPostBadRequest struct {
	Payload *models.Error
}

func (o *PcloudNetworksPostBadRequest) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostBadRequest  %+v", 400, o.Payload)
}

func (o *PcloudNetworksPostBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPcloudNetworksPostUnauthorized creates a PcloudNetworksPostUnauthorized with default headers values
func NewPcloudNetworksPostUnauthorized() *PcloudNetworksPostUnauthorized {
	return &PcloudNetworksPostUnauthorized{}
}

/*PcloudNetworksPostUnauthorized handles this case with default header values.

Unauthorized
*/
type PcloudNetworksPostUnauthorized struct {
	Payload *models.Error
}

func (o *PcloudNetworksPostUnauthorized) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostUnauthorized  %+v", 401, o.Payload)
}

func (o *PcloudNetworksPostUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPcloudNetworksPostConflict creates a PcloudNetworksPostConflict with default headers values
func NewPcloudNetworksPostConflict() *PcloudNetworksPostConflict {
	return &PcloudNetworksPostConflict{}
}

/*PcloudNetworksPostConflict handles this case with default header values.

Conflict
*/
type PcloudNetworksPostConflict struct {
	Payload *models.Error
}

func (o *PcloudNetworksPostConflict) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostConflict  %+v", 409, o.Payload)
}

func (o *PcloudNetworksPostConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPcloudNetworksPostUnprocessableEntity creates a PcloudNetworksPostUnprocessableEntity with default headers values
func NewPcloudNetworksPostUnprocessableEntity() *PcloudNetworksPostUnprocessableEntity {
	return &PcloudNetworksPostUnprocessableEntity{}
}

/*PcloudNetworksPostUnprocessableEntity handles this case with default header values.

Unprocessable Entity
*/
type PcloudNetworksPostUnprocessableEntity struct {
	Payload *models.Error
}

func (o *PcloudNetworksPostUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PcloudNetworksPostUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPcloudNetworksPostInternalServerError creates a PcloudNetworksPostInternalServerError with default headers values
func NewPcloudNetworksPostInternalServerError() *PcloudNetworksPostInternalServerError {
	return &PcloudNetworksPostInternalServerError{}
}

/*PcloudNetworksPostInternalServerError handles this case with default header values.

Internal Server Error
*/
type PcloudNetworksPostInternalServerError struct {
	Payload *models.Error
}

func (o *PcloudNetworksPostInternalServerError) Error() string {
	return fmt.Sprintf("[POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks][%d] pcloudNetworksPostInternalServerError  %+v", 500, o.Payload)
}

func (o *PcloudNetworksPostInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
