// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_v_p_n_connections

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewPcloudVpnconnectionsPutParams creates a new PcloudVpnconnectionsPutParams object
// with the default values initialized.
func NewPcloudVpnconnectionsPutParams() *PcloudVpnconnectionsPutParams {
	var ()
	return &PcloudVpnconnectionsPutParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPcloudVpnconnectionsPutParamsWithTimeout creates a new PcloudVpnconnectionsPutParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPcloudVpnconnectionsPutParamsWithTimeout(timeout time.Duration) *PcloudVpnconnectionsPutParams {
	var ()
	return &PcloudVpnconnectionsPutParams{

		timeout: timeout,
	}
}

// NewPcloudVpnconnectionsPutParamsWithContext creates a new PcloudVpnconnectionsPutParams object
// with the default values initialized, and the ability to set a context for a request
func NewPcloudVpnconnectionsPutParamsWithContext(ctx context.Context) *PcloudVpnconnectionsPutParams {
	var ()
	return &PcloudVpnconnectionsPutParams{

		Context: ctx,
	}
}

// NewPcloudVpnconnectionsPutParamsWithHTTPClient creates a new PcloudVpnconnectionsPutParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPcloudVpnconnectionsPutParamsWithHTTPClient(client *http.Client) *PcloudVpnconnectionsPutParams {
	var ()
	return &PcloudVpnconnectionsPutParams{
		HTTPClient: client,
	}
}

/*PcloudVpnconnectionsPutParams contains all the parameters to send to the API endpoint
for the pcloud vpnconnections put operation typically these are written to a http.Request
*/
type PcloudVpnconnectionsPutParams struct {

	/*Body
	  VPN Connection object used for update

	*/
	Body *models.VPNConnectionUpdate
	/*CloudInstanceID
	  Cloud Instance ID of a PCloud Instance

	*/
	CloudInstanceID string
	/*VpnConnectionID
	  ID of a VPN connection

	*/
	VpnConnectionID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) WithTimeout(timeout time.Duration) *PcloudVpnconnectionsPutParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) WithContext(ctx context.Context) *PcloudVpnconnectionsPutParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) WithHTTPClient(client *http.Client) *PcloudVpnconnectionsPutParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) WithBody(body *models.VPNConnectionUpdate) *PcloudVpnconnectionsPutParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) SetBody(body *models.VPNConnectionUpdate) {
	o.Body = body
}

// WithCloudInstanceID adds the cloudInstanceID to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) WithCloudInstanceID(cloudInstanceID string) *PcloudVpnconnectionsPutParams {
	o.SetCloudInstanceID(cloudInstanceID)
	return o
}

// SetCloudInstanceID adds the cloudInstanceId to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) SetCloudInstanceID(cloudInstanceID string) {
	o.CloudInstanceID = cloudInstanceID
}

// WithVpnConnectionID adds the vpnConnectionID to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) WithVpnConnectionID(vpnConnectionID string) *PcloudVpnconnectionsPutParams {
	o.SetVpnConnectionID(vpnConnectionID)
	return o
}

// SetVpnConnectionID adds the vpnConnectionId to the pcloud vpnconnections put params
func (o *PcloudVpnconnectionsPutParams) SetVpnConnectionID(vpnConnectionID string) {
	o.VpnConnectionID = vpnConnectionID
}

// WriteToRequest writes these params to a swagger request
func (o *PcloudVpnconnectionsPutParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param cloud_instance_id
	if err := r.SetPathParam("cloud_instance_id", o.CloudInstanceID); err != nil {
		return err
	}

	// path param vpn_connection_id
	if err := r.SetPathParam("vpn_connection_id", o.VpnConnectionID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
