// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_v_p_n_policies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewPcloudIkepoliciesPutParams creates a new PcloudIkepoliciesPutParams object
// with the default values initialized.
func NewPcloudIkepoliciesPutParams() *PcloudIkepoliciesPutParams {
	var ()
	return &PcloudIkepoliciesPutParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPcloudIkepoliciesPutParamsWithTimeout creates a new PcloudIkepoliciesPutParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPcloudIkepoliciesPutParamsWithTimeout(timeout time.Duration) *PcloudIkepoliciesPutParams {
	var ()
	return &PcloudIkepoliciesPutParams{

		timeout: timeout,
	}
}

// NewPcloudIkepoliciesPutParamsWithContext creates a new PcloudIkepoliciesPutParams object
// with the default values initialized, and the ability to set a context for a request
func NewPcloudIkepoliciesPutParamsWithContext(ctx context.Context) *PcloudIkepoliciesPutParams {
	var ()
	return &PcloudIkepoliciesPutParams{

		Context: ctx,
	}
}

// NewPcloudIkepoliciesPutParamsWithHTTPClient creates a new PcloudIkepoliciesPutParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPcloudIkepoliciesPutParamsWithHTTPClient(client *http.Client) *PcloudIkepoliciesPutParams {
	var ()
	return &PcloudIkepoliciesPutParams{
		HTTPClient: client,
	}
}

/*PcloudIkepoliciesPutParams contains all the parameters to send to the API endpoint
for the pcloud ikepolicies put operation typically these are written to a http.Request
*/
type PcloudIkepoliciesPutParams struct {

	/*Body
	  Parameters for updating IKE Policy

	*/
	Body *models.IKEPolicyUpdate
	/*CloudInstanceID
	  Cloud Instance ID of a PCloud Instance

	*/
	CloudInstanceID string
	/*IkePolicyID
	  ID of a IKE Policy

	*/
	IkePolicyID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) WithTimeout(timeout time.Duration) *PcloudIkepoliciesPutParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) WithContext(ctx context.Context) *PcloudIkepoliciesPutParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) WithHTTPClient(client *http.Client) *PcloudIkepoliciesPutParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) WithBody(body *models.IKEPolicyUpdate) *PcloudIkepoliciesPutParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) SetBody(body *models.IKEPolicyUpdate) {
	o.Body = body
}

// WithCloudInstanceID adds the cloudInstanceID to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) WithCloudInstanceID(cloudInstanceID string) *PcloudIkepoliciesPutParams {
	o.SetCloudInstanceID(cloudInstanceID)
	return o
}

// SetCloudInstanceID adds the cloudInstanceId to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) SetCloudInstanceID(cloudInstanceID string) {
	o.CloudInstanceID = cloudInstanceID
}

// WithIkePolicyID adds the ikePolicyID to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) WithIkePolicyID(ikePolicyID string) *PcloudIkepoliciesPutParams {
	o.SetIkePolicyID(ikePolicyID)
	return o
}

// SetIkePolicyID adds the ikePolicyId to the pcloud ikepolicies put params
func (o *PcloudIkepoliciesPutParams) SetIkePolicyID(ikePolicyID string) {
	o.IkePolicyID = ikePolicyID
}

// WriteToRequest writes these params to a swagger request
func (o *PcloudIkepoliciesPutParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param cloud_instance_id
	if err := r.SetPathParam("cloud_instance_id", o.CloudInstanceID); err != nil {
		return err
	}

	// path param ike_policy_id
	if err := r.SetPathParam("ike_policy_id", o.IkePolicyID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
