// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_v_p_n_policies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewPcloudIpsecpoliciesPostParams creates a new PcloudIpsecpoliciesPostParams object
// with the default values initialized.
func NewPcloudIpsecpoliciesPostParams() *PcloudIpsecpoliciesPostParams {
	var ()
	return &PcloudIpsecpoliciesPostParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPcloudIpsecpoliciesPostParamsWithTimeout creates a new PcloudIpsecpoliciesPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPcloudIpsecpoliciesPostParamsWithTimeout(timeout time.Duration) *PcloudIpsecpoliciesPostParams {
	var ()
	return &PcloudIpsecpoliciesPostParams{

		timeout: timeout,
	}
}

// NewPcloudIpsecpoliciesPostParamsWithContext creates a new PcloudIpsecpoliciesPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewPcloudIpsecpoliciesPostParamsWithContext(ctx context.Context) *PcloudIpsecpoliciesPostParams {
	var ()
	return &PcloudIpsecpoliciesPostParams{

		Context: ctx,
	}
}

// NewPcloudIpsecpoliciesPostParamsWithHTTPClient creates a new PcloudIpsecpoliciesPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPcloudIpsecpoliciesPostParamsWithHTTPClient(client *http.Client) *PcloudIpsecpoliciesPostParams {
	var ()
	return &PcloudIpsecpoliciesPostParams{
		HTTPClient: client,
	}
}

/*PcloudIpsecpoliciesPostParams contains all the parameters to send to the API endpoint
for the pcloud ipsecpolicies post operation typically these are written to a http.Request
*/
type PcloudIpsecpoliciesPostParams struct {

	/*Body
	  Parameters for the creation of a new IPSec Policy

	*/
	Body *models.IPSecPolicyCreate
	/*CloudInstanceID
	  Cloud Instance ID of a PCloud Instance

	*/
	CloudInstanceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) WithTimeout(timeout time.Duration) *PcloudIpsecpoliciesPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) WithContext(ctx context.Context) *PcloudIpsecpoliciesPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) WithHTTPClient(client *http.Client) *PcloudIpsecpoliciesPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) WithBody(body *models.IPSecPolicyCreate) *PcloudIpsecpoliciesPostParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) SetBody(body *models.IPSecPolicyCreate) {
	o.Body = body
}

// WithCloudInstanceID adds the cloudInstanceID to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) WithCloudInstanceID(cloudInstanceID string) *PcloudIpsecpoliciesPostParams {
	o.SetCloudInstanceID(cloudInstanceID)
	return o
}

// SetCloudInstanceID adds the cloudInstanceId to the pcloud ipsecpolicies post params
func (o *PcloudIpsecpoliciesPostParams) SetCloudInstanceID(cloudInstanceID string) {
	o.CloudInstanceID = cloudInstanceID
}

// WriteToRequest writes these params to a swagger request
func (o *PcloudIpsecpoliciesPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param cloud_instance_id
	if err := r.SetPathParam("cloud_instance_id", o.CloudInstanceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
