// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_volumes

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewPcloudV2VolumesclonePostParams creates a new PcloudV2VolumesclonePostParams object
// with the default values initialized.
func NewPcloudV2VolumesclonePostParams() *PcloudV2VolumesclonePostParams {
	var ()
	return &PcloudV2VolumesclonePostParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPcloudV2VolumesclonePostParamsWithTimeout creates a new PcloudV2VolumesclonePostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPcloudV2VolumesclonePostParamsWithTimeout(timeout time.Duration) *PcloudV2VolumesclonePostParams {
	var ()
	return &PcloudV2VolumesclonePostParams{

		timeout: timeout,
	}
}

// NewPcloudV2VolumesclonePostParamsWithContext creates a new PcloudV2VolumesclonePostParams object
// with the default values initialized, and the ability to set a context for a request
func NewPcloudV2VolumesclonePostParamsWithContext(ctx context.Context) *PcloudV2VolumesclonePostParams {
	var ()
	return &PcloudV2VolumesclonePostParams{

		Context: ctx,
	}
}

// NewPcloudV2VolumesclonePostParamsWithHTTPClient creates a new PcloudV2VolumesclonePostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPcloudV2VolumesclonePostParamsWithHTTPClient(client *http.Client) *PcloudV2VolumesclonePostParams {
	var ()
	return &PcloudV2VolumesclonePostParams{
		HTTPClient: client,
	}
}

/*PcloudV2VolumesclonePostParams contains all the parameters to send to the API endpoint
for the pcloud v2 volumesclone post operation typically these are written to a http.Request
*/
type PcloudV2VolumesclonePostParams struct {

	/*Body
	  Parameters for preparing a set of volumes to be cloned

	*/
	Body *models.VolumesCloneCreate
	/*CloudInstanceID
	  Cloud Instance ID of a PCloud Instance

	*/
	CloudInstanceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) WithTimeout(timeout time.Duration) *PcloudV2VolumesclonePostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) WithContext(ctx context.Context) *PcloudV2VolumesclonePostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) WithHTTPClient(client *http.Client) *PcloudV2VolumesclonePostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) WithBody(body *models.VolumesCloneCreate) *PcloudV2VolumesclonePostParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) SetBody(body *models.VolumesCloneCreate) {
	o.Body = body
}

// WithCloudInstanceID adds the cloudInstanceID to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) WithCloudInstanceID(cloudInstanceID string) *PcloudV2VolumesclonePostParams {
	o.SetCloudInstanceID(cloudInstanceID)
	return o
}

// SetCloudInstanceID adds the cloudInstanceId to the pcloud v2 volumesclone post params
func (o *PcloudV2VolumesclonePostParams) SetCloudInstanceID(cloudInstanceID string) {
	o.CloudInstanceID = cloudInstanceID
}

// WriteToRequest writes these params to a swagger request
func (o *PcloudV2VolumesclonePostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param cloud_instance_id
	if err := r.SetPathParam("cloud_instance_id", o.CloudInstanceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
